library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity fibonacci is
	generic(N :integer :=16);
	port( 
		clk, rst 	: in std_logic;
		fibo_s		: out std_logic_vector(N-1 downto 0)
);
end fibonacci;
architecture fib_arch of fibonacci is
	signal a :unsigned(N-1 downto 0);
	signal b_reg :unsigned(N-1 downto 0); 
	signal b_next :unsigned(N-1 downto 0); 
	signal c_reg :unsigned(N-1 downto 0);
	signal c_next :unsigned(N-1 downto 0);
	begin
	process(clk, rst)
	begin
		if(rst='1')then 
			b_reg <= to_unsigned(1, N); 
			c_reg <= to_unsigned(0, N);
		elsif(clk'event and clk='1')then
			c_reg <= c_next; 
			b_reg <= b_next;  
		end if;
	end process;
	process(a, b_reg, c_reg)
	begin
		b_next <= a;
		c_next <= b_reg;
		a <= b_reg + c_reg;
	end process; 
	fibo_s <= std_logic_vector(a);
end fib_arch;
