library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity counter is
generic(
	N : integer := 4
);
port(
	clk, rst  :in  std_logic;
	input	:in  std_logic_vector(N-1 downto 0);
	load	:in  std_logic;
	output	:out std_logic_vector(N-1 downto 0)
);
end counter;

architecture cnt_arch of counter is
	signal counter_reg, counter_next : unsigned(N-1 downto 0);
begin
	process(rst, clk)
	begin 
		if rst = '1' then
			counter_reg <= (others => '0');
        elsif rising_edge(clk) then
			counter_reg <= counter_next;
		end if;
    end process;

	process(load, input, counter_reg)
	begin
		if load = '1' then
			counter_next <= unsigned(input);
		elsif counter_reg = 0 then
			counter_next <= counter_reg;
		else
			counter_next <= counter_reg - 1;
		end if;
	end process;

    output <= std_logic_vector(counter_reg);
end cnt_arch;

