library ieee;
use ieee.std_logic_1164.all;

entity fib is
generic(
	N : integer := 16
);
port(
	rst, clk, start	: in std_logic;
	x_i, y_i, c_i	: in std_logic_vector(N-1 downto 0);
	ready : out std_logic;
	d_o	: out std_logic_vector(N-1 downto 0)
);
end fib;

architecture fib_arch of fib is

component fsm is
port(
	rst, clk	: in std_logic;
	comp, start	: in std_logic;
	first_sel, second_sel : out  std_logic;
	first_load, second_load, counter_load : out  std_logic;
	ready	: out std_logic
);
end component;

component dp is
generic(
	N : integer := 4
);
port(   
	rst, clk	: in  std_logic;
	first, second, count	: in  std_logic_vector(N-1 downto 0); 
	first_sel, second_sel : in  std_logic;
	first_load, second_load, counter_load : in  std_logic;
	comp_out	: out std_logic;  
	output	: out std_logic_vector(N-1 downto 0)
);
end component;

	signal f_load, s_load, c_load, f_sel, s_sel, comp :std_logic;
begin
fsm_inst :fsm port map(rst => rst, clk => clk, comp => comp, start => start, first_sel => f_sel, second_sel => s_sel,
	first_load => f_load, second_load => s_load, counter_load => c_load, ready => ready);

dp_inst : dp generic map(N => N) port map(rst => rst, clk => clk, first => x_i, second => y_i, count => c_i,
	first_sel => f_sel, second_sel => s_sel,
	first_load => f_load, second_load => s_load, counter_load => c_load, comp_out => comp, output => d_o);
end fib_arch;
