library ieee;
use ieee.std_logic_1164.all;

entity reg is
generic(
	N : integer := 4
);
port(
	rst, clk, load	: in std_logic;
	input	: in std_logic_vector(N-1 downto 0);
	output	: out std_logic_vector(N-1 downto 0)
);
end reg;

architecture reg_arch of reg is
	signal reg_reg, reg_next : std_logic_vector(N-1 downto 0);
begin
	process(rst, clk)
	begin 
		if rst = '1' then
			reg_reg <= (others => '0');
		elsif rising_edge(clk) then
			reg_reg <= reg_next;
		end if;
	end process;
	
	process(load, input, reg_reg)
	begin
		if load = '1' then
			reg_next <= input;
		else
			reg_next <= reg_reg;
		end if;
	end process;

	output <= reg_reg;
end reg_arch;